# -*- coding: utf-8 -*-
import os
import time
import oss2

from resource import pcdtovideo_pji_deepcamera

import logging

path1 = '/mnt/disk001/dcl_data_process/src/python2/pjibot/'
path2 = '/mnt/disk001/dcl_data_process/src/python2/pjibot/resource/'
logging.basicConfig(filename=path1 + 'log/pcd.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

key1 = 'pjibot/'
sleep_time = 60  # 每多少秒扫描一次


def parse_to_pcd_mp4(merged_bag_file_path, parse_prefix2, local_parse_dir, local_delete_list):
    global bucket
    try:
        # local_pcd_mp4_dir1 = pcdtovideo_pji_deepcamera.parse1('/ob_camera_01/depth/points', merged_bag_file_path,
        #                                                       local_parse_dir + '/depth1/')
        # local_pcd_mp4_dir2 = pcdtovideo_pji_deepcamera.parse2('/ob_camera_02/depth/points', merged_bag_file_path,
        #                                                       local_parse_dir + '/depth2/')

        os.chdir(path2)
        command1 = 'sh run.sh ' + merged_bag_file_path + ' ' + local_parse_dir
        logging.info("调用命令lidar视频生成命令: %s" % str(command1))
        os.system(command1)

        file_name_with_extension = os.path.basename(merged_bag_file_path)
        file_name_without_extension = os.path.splitext(file_name_with_extension)[0]
        parent_directory = os.path.dirname(merged_bag_file_path)
        local_pcd_mp4_dir3 = parent_directory.replace('data_merge',
                                                      'data_parse') + '/' + file_name_without_extension + '_pcd_lidar'
        # local_pcd_mp4_dir3 = pcdtovideo_pji_lidar.parse(merged_bag_file_path, local_parse_dir + '/lidar/')

        # pcd_mp4_file_name1 = 'pcd_depthcamera'
        # pcd_mp4_file_name2 = 'pcd_depthcamera2'
        pcd_mp4_file_name3 = 'pcd_lidar'
        # local_delete_list.append(local_pcd_mp4_dir1 + '/' + pcd_mp4_file_name1 + '.mp4')
        # local_delete_list.append(local_pcd_mp4_dir2 + '/' + pcd_mp4_file_name2 + '.mp4')
        local_delete_list.append(local_pcd_mp4_dir3 + '/output_video_converted.mp4')
        # oss_csv_object_key1 = parse_prefix2 + pcd_mp4_file_name1 + '.mp4'
        # oss_csv_object_key2 = parse_prefix2 + pcd_mp4_file_name2 + '.mp4'
        oss_csv_object_key3 = parse_prefix2 + pcd_mp4_file_name3 + '.mp4'
        # bucket.put_object_from_file(oss_csv_object_key1, local_pcd_mp4_dir1 + '/' + pcd_mp4_file_name1 + '.mp4')
        # logging.info("上传点云视频到: %s", oss_csv_object_key1)
        # bucket.put_object_from_file(oss_csv_object_key2, local_pcd_mp4_dir2 + '/' + pcd_mp4_file_name2 + '.mp4')
        # logging.info("上传点云视频到: %s", oss_csv_object_key2)
        bucket.put_object_from_file(oss_csv_object_key3, local_pcd_mp4_dir3 + '/output_video_converted.mp4')
        logging.info("上传点云视频到: %s", oss_csv_object_key3)
    except Exception as e:
        logging.exception("生成点云视频报错: %s" % str(e))
        # for obj in oss2.ObjectIterator(bucket, prefix=parse_prefix2):
        #     bucket.delete_object(obj.key)


'''
cname：http://open-bucket.oss.icvdc.com
内网endpoint: oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com
oss桶名： open-bucket
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
'''
# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    # cname = 'http://open-bucket.oss.icvdc.com'
    # bucket = oss2.Bucket(auth, cname, 'open-bucket', is_cname=True)
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'pji-bucket1')
    while True:
        logging.info("开始新一轮扫描")
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                try:
                    # 获取合并后的包
                    merged_bag_object_key = str(obj1.key)
                    # print(f'判断1{merged_bag_object_key}')
                    if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                        merged_bag_object_key_split = merged_bag_object_key.split('/')
                        merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                        parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                        parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                        # pcd1_done = False
                        # pcd2_done = False
                        pcd3_done = False
                        callback_done = False
                        for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                            if '/callback.json' in str(obj2.key):
                                callback_done = True
                            # if '/pcd_depthcamera.mp4' in str(obj2.key):
                            #     pcd1_done = True
                            if '/pcd_lidar.mp4' in str(obj2.key):
                                pcd3_done = True
                        if pcd3_done:
                            # logging.info( "%s 存在点云视频 pcd_depthcamera.mp4 和 pcd_lidar.mp4" % str(parse_prefix_full))
                            # logging.info("%s 存在点云视频 pcd_lidar.mp4 " % str(parse_prefix_full))
                            continue
                        if not callback_done:
                            # logging.info("数据已回调完成，不需要处理: %s" % str(parse_prefix_full))
                            continue
                        logging.info("%s 缺少点云视频 pcd_depthcamera.mp4 和 pcd_lidar.mp4" % str(parse_prefix_full))
                        # print(f'需要解析{merged_bag_object_key}')
                        local_merged_bag_path = path1 + 'pcd/' + merged_bag_object_key
                        local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                        local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                        if not os.path.exists(local_merged_dir):
                            os.makedirs(local_merged_dir)
                        if not os.path.exists(local_parse_dir):
                            os.makedirs(local_parse_dir)
                        merged_bag_full_name = merged_bag_object_key_split[-1]
                        merged_bag_name = merged_bag_full_name.split('.')[0]
                        bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                        local_delete_list.append(local_merged_bag_path)
                        # 2 生成 pos_orig.csv 和 pos_hmi.csv
                        parse_to_pcd_mp4(local_merged_bag_path, parse_prefix_full, local_parse_dir, local_delete_list)
                except Exception as e:
                    logging.exception("报错: %s" % str(e))
            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("删除本地临时文件报错: %s" % str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局异常处理: %s" % str(e))
